#!/usr/bin/python

import os.path
import re
import sys

interface_name = re.compile(r'("PPB_.+;\d+\.\d+")')

root = os.environ.get("NACL_SDK_ROOT")
if root is None:
  print "NACL_SDK_ROOT must be set."
  sys.exit(1)

root = os.path.join(root, "include", "ppapi", "c")

interfaces = []
for path, dirs, files in os.walk(root):
  for fn in files:
    if not (fn.startswith("ppb_") and fn.endswith(".h")):
      continue
    full = os.path.join(path, fn)
    print full
    interfaces.extend(interface_name.findall(open(full).read()))

interfaces.sort()

out = open("interfaces.h", "w")
out.write("/* This file is automatically generated. Do not edit. */\n\n")
out.write("const char* interfaces[] = {\n");
for interface in interfaces:
  out.write("  %s,\n" % interface)
out.write("  NULL\n};");
out.close()
